/* This file is a part of the program Kira.
 * Copyright (C) Johann Usovitsch <jusovitsch@googlemail.com>
 * Philipp Maierhoefer <particle@maierhoefer.net>
 * Peter Uwer <peter.uwer@physik.hu-berlin.de>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version , or (at
 * your option) any later version as published by the Free Software 
 * Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
*/
#ifndef COEFFICIENTS_H
#define COEFFICIENTS_H

#include <string>
#include <utility>
#include <vector>
#include <exception>
#include <limits>

#include "defs.h"

namespace pyred
{

bool is_valid_varname(const std::string& s);

const std::vector<uint64_t>& primes();
uint64_t randvar_lbound();
constexpr intid noint() {return std::numeric_limits<pyred::intid>::max();}
void random_seed(int);
uint64_t random_minmax(uint64_t, uint64_t);
uint64_t mod_mul(uint64_t, uint64_t, uint64_t);
uint64_t mod_pow(uint64_t, uint64_t, uint64_t);
uint64_t mod_inv(uint64_t, uint64_t);

}

#endif
